
public class Performance {

	int count;
	
	public Performance() {
		count = 0;
	}
	
	public void test() {
		count++;
	}
	
	public static void main(String[] args) {
		
		long start_s, end_s;
		long start_r, end_r;
		int n = 1000000;
		Performance p;
		
		p = new Performance();
		start_s = System.nanoTime();
		for (int i=0 ; i<n ; i++) {
			p.test();
		}
		end_s = System.nanoTime();
		
		p = new Performance();
		start_r = System.nanoTime();
		for (int i=0 ; i<n ; i++) {
			try {
				p.getClass().getMethod("test").invoke(p);
			} catch (Exception e) {}
		}
		end_r = System.nanoTime();
		
		System.out.print("Mean time for standard method call (ns): ");
		System.out.println((end_s-start_s)/n);
		System.out.print("Mean time for reflexive method call (ns): ");
		System.out.println((end_r-start_r)/n);
		System.out.print("-------\nSlowdown factor: ");
		System.out.println((end_r-start_r)/(end_s-start_s));

	}

}
